VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Collision detection"
   ClientHeight    =   7320
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11295
   LinkTopic       =   "Form1"
   ScaleHeight     =   7320
   ScaleWidth      =   11295
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label1 
      Caption         =   "Left-Click selects, Right-Click drops"
      Height          =   255
      Left            =   0
      TabIndex        =   10
      Top             =   7080
      Width           =   2535
   End
   Begin VB.Label MouseOverCircle 
      Caption         =   "MouseOverCircle2"
      Height          =   255
      Index           =   2
      Left            =   0
      TabIndex        =   9
      Top             =   1080
      Width           =   3255
   End
   Begin VB.Label MouseOverCircle 
      Caption         =   "MouseOverCircle1"
      Height          =   255
      Index           =   1
      Left            =   0
      TabIndex        =   8
      Top             =   720
      Width           =   3255
   End
   Begin VB.Label Circle2Box2 
      Caption         =   "Circle2Box2"
      Height          =   255
      Left            =   8280
      TabIndex        =   7
      Top             =   1080
      Width           =   3375
   End
   Begin VB.Label Circle2Box1 
      Caption         =   "Circle2Box1"
      Height          =   255
      Left            =   8280
      TabIndex        =   6
      Top             =   720
      Width           =   3015
   End
   Begin VB.Label Circle1Box2 
      Caption         =   "Circle1Box2"
      Height          =   255
      Left            =   8280
      TabIndex        =   5
      Top             =   360
      Width           =   3015
   End
   Begin VB.Label Circle1Box1 
      Caption         =   "Circle1Box1"
      Height          =   255
      Left            =   8280
      TabIndex        =   4
      Top             =   0
      Width           =   3015
   End
   Begin VB.Label CircleOverCircle 
      Caption         =   "CircleOverCircle"
      Height          =   255
      Left            =   3840
      TabIndex        =   3
      Top             =   360
      Width           =   3375
   End
   Begin VB.Label BoxOverBox 
      Caption         =   "BoxOverBox"
      Height          =   255
      Left            =   3840
      TabIndex        =   2
      Top             =   0
      Width           =   3375
   End
   Begin VB.Label MouseOverBox 
      Caption         =   "MouseOverBox2"
      Height          =   255
      Index           =   2
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   3255
   End
   Begin VB.Shape Circle2 
      FillColor       =   &H000000FF&
      FillStyle       =   0  'Solid
      Height          =   2415
      Left            =   3360
      Shape           =   3  'Circle
      Top             =   4320
      Width           =   2415
   End
   Begin VB.Shape Circle1 
      FillColor       =   &H0000C000&
      FillStyle       =   0  'Solid
      Height          =   1455
      Left            =   8640
      Shape           =   3  'Circle
      Top             =   3000
      Width           =   1455
   End
   Begin VB.Shape Box2 
      FillColor       =   &H00FF0000&
      FillStyle       =   0  'Solid
      Height          =   1575
      Left            =   5760
      Top             =   2280
      Width           =   2055
   End
   Begin VB.Shape Box1 
      FillStyle       =   0  'Solid
      Height          =   1815
      Left            =   1080
      Top             =   2160
      Width           =   1935
   End
   Begin VB.Label MouseOverBox 
      Caption         =   "MouseOverBox1"
      Height          =   255
      Index           =   1
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim Over(1 To 2) As Boolean, Overlap As Boolean
Dim MoveThis As Shape 'The shape to move using the mouse
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Over(1) = False 'The mouse is not within the square unless all conditions below are met
    'Collision detection with mouse & box1
    If X >= Box1.Left Then
        If X <= Box1.Left + Box1.Width Then
            If Y >= Box1.Top Then
                If Y <= Box1.Top + Box1.Height Then
                    Over(1) = True
                End If
            End If
        End If
    End If
    If Over(1) = True Then
        MouseOverBox(1).Caption = "The mouse is over the black box"
    Else
        MouseOverBox(1).Caption = "The mouse is NOT over the black box"
    End If
    
    Over(2) = False 'The mouse is not within the square unless all conditions below are met
    'Collision detection with mouse & box2
    If X >= Box2.Left Then
        If X <= Box2.Left + Box2.Width Then
            If Y >= Box2.Top Then
                If Y <= Box2.Top + Box2.Height Then
                    Over(2) = True
                End If
            End If
        End If
    End If
    If Over(2) = True Then
        MouseOverBox(2).Caption = "The mouse is over the blue box"
    Else
        MouseOverBox(2).Caption = "The mouse is NOT over the blue box"
    End If
    
    'Collision detection with mouse & circle1
    Over(1) = False 'The mouse is not on the circle unless the condition below is met
    If Sqr(CDbl((X - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Y - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Over(1) = True
    End If
    If Over(1) = True Then
        MouseOverCircle(1).Caption = "The mouse is over the green circle"
    Else
        MouseOverCircle(1).Caption = "The mouse is NOT over the green circle"
    End If
    
    'Collision detection with mouse & circle2
    Over(2) = False 'The mouse is not on the circle unless the condition below is met
    If Sqr(CDbl((X - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Y - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Over(2) = True
    End If
    If Over(2) = True Then
        MouseOverCircle(2).Caption = "The mouse is over the red circle"
    Else
        MouseOverCircle(2).Caption = "The mouse is NOT over the red circle"
    End If
    
    
    Overlap = False
    'Collision detection with box 1 & box2
    If Box1.Left <= Box2.Left + Box2.Width Then
        If Box1.Left + Box1.Width >= Box2.Left Then
            If Box1.Top <= Box2.Top + Box2.Height Then
                If Box1.Top + Box1.Height >= Box2.Top Then
                    Overlap = True
                End If
            End If
        End If
    End If
    If Overlap = True Then
        BoxOverBox.Caption = "Box1 and Box2 are overlapping"
    Else
        BoxOverBox.Caption = "Box1 and Box2 are NOT overlapping"
    End If
    
    Overlap = False
    'Collision detection with Circle1 & Circle2
    If Sqr(CDbl((Circle2.Left + (Circle2.Width / 2) - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Circle2.Top + (Circle2.Height / 2) - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= (Circle1.Width / 2) + (Circle2.Width / 2) Then
        Overlap = True
    End If
    If Overlap = True Then
        CircleOverCircle.Caption = "Circle1 and Circle2 are overlapping"
    Else
        CircleOverCircle.Caption = "Circle1 and Circle2 are NOT overlapping"
    End If
    
    Overlap = False
    'Collision detection with Circle1 & box1
    If Sqr(CDbl((Box1.Left + Box1.Width - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Box1.Top + Box1.Height - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Overlap = True 'Circle1 hit the bottom right of the box
    End If
    If Sqr(CDbl((Box1.Left - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Box1.Top + Box1.Height - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Overlap = True 'Circle1 hit the bottom left of the box
    End If
    If Sqr(CDbl((Box1.Left + Box1.Width - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Box1.Top - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Overlap = True 'Circle1 hit the top right of the box
    End If
    If Sqr(CDbl((Box1.Left - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Box1.Top - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Overlap = True 'Circle1 hit the top left of the box
    End If
    If Abs(Circle1.Left + (Circle1.Width / 2) - Box1.Left - (Box1.Width / 2)) <= (Circle1.Width + Box1.Width) / 2 Then
        If Abs(Circle1.Top + (Circle1.Height / 2) - Box1.Top - (Box1.Height / 2)) <= Box1.Height / 2 Then
            Overlap = True
        End If
    End If
    If Abs(Circle1.Top + (Circle1.Height / 2) - Box1.Top - (Box1.Height / 2)) <= (Circle1.Height + Box1.Height) / 2 Then
        If Abs(Circle1.Left + (Circle1.Width / 2) - Box1.Left - (Box1.Width / 2)) <= Box1.Width / 2 Then
            Overlap = True
        End If
    End If
    If Overlap = True Then
        Circle1Box1.Caption = "Circle1 and Box1 are overlapping"
    Else
        Circle1Box1.Caption = "Circle1 and Box1 are NOT overlapping"
    End If
    
    
    Overlap = False
    'Collision detection with Circle1 & box2
    If Sqr(CDbl((Box2.Left + Box2.Width - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Box2.Top + Box2.Height - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Overlap = True 'Circle1 hit the bottom right of the box
    End If
    If Sqr(CDbl((Box2.Left - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Box2.Top + Box2.Height - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Overlap = True 'Circle1 hit the bottom left of the box
    End If
    If Sqr(CDbl((Box2.Left + Box2.Width - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Box2.Top - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Overlap = True 'Circle1 hit the top right of the box
    End If
    If Sqr(CDbl((Box2.Left - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Box2.Top - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Overlap = True 'Circle1 hit the top left of the box
    End If
    If Abs(Circle1.Left + (Circle1.Width / 2) - Box2.Left - (Box2.Width / 2)) <= (Circle1.Width + Box2.Width) / 2 Then
        If Abs(Circle1.Top + (Circle1.Height / 2) - Box2.Top - (Box2.Height / 2)) <= Box2.Height / 2 Then
            Overlap = True
        End If
    End If
    If Abs(Circle1.Top + (Circle1.Height / 2) - Box2.Top - (Box2.Height / 2)) <= (Circle1.Height + Box2.Height) / 2 Then
        If Abs(Circle1.Left + (Circle1.Width / 2) - Box2.Left - (Box2.Width / 2)) <= Box2.Width / 2 Then
            Overlap = True
        End If
    End If
    If Overlap = True Then
        Circle1Box2.Caption = "Circle1 and Box2 are overlapping"
    Else
        Circle1Box2.Caption = "Circle1 and Box2 are NOT overlapping"
    End If
    
    Overlap = False
    'Collision detection with circle2 & box1
    If Sqr(CDbl((Box1.Left + Box1.Width - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Box1.Top + Box1.Height - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Overlap = True 'circle2 hit the bottom right of the box
    End If
    If Sqr(CDbl((Box1.Left - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Box1.Top + Box1.Height - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Overlap = True 'circle2 hit the bottom left of the box
    End If
    If Sqr(CDbl((Box1.Left + Box1.Width - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Box1.Top - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Overlap = True 'circle2 hit the top right of the box
    End If
    If Sqr(CDbl((Box1.Left - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Box1.Top - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Overlap = True 'circle2 hit the top left of the box
    End If
    If Abs(Circle2.Left + (Circle2.Width / 2) - Box1.Left - (Box1.Width / 2)) <= (Circle2.Width + Box1.Width) / 2 Then
        If Abs(Circle2.Top + (Circle2.Height / 2) - Box1.Top - (Box1.Height / 2)) <= Box1.Height / 2 Then
            Overlap = True
        End If
    End If
    If Abs(Circle2.Top + (Circle2.Height / 2) - Box1.Top - (Box1.Height / 2)) <= (Circle2.Height + Box1.Height) / 2 Then
        If Abs(Circle2.Left + (Circle2.Width / 2) - Box1.Left - (Box1.Width / 2)) <= Box1.Width / 2 Then
            Overlap = True
        End If
    End If
    If Overlap = True Then
        Circle2Box1.Caption = "Circle2 and Box1 are overlapping"
    Else
        Circle2Box1.Caption = "Circle2 and Box1 are NOT overlapping"
    End If
    
    
    Overlap = False
    'Collision detection with circle2 & box2
    If Sqr(CDbl((Box2.Left + Box2.Width - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Box2.Top + Box2.Height - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Overlap = True 'circle2 hit the bottom right of the box
    End If
    If Sqr(CDbl((Box2.Left - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Box2.Top + Box2.Height - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Overlap = True 'circle2 hit the bottom left of the box
    End If
    If Sqr(CDbl((Box2.Left + Box2.Width - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Box2.Top - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Overlap = True 'circle2 hit the top right of the box
    End If
    If Sqr(CDbl((Box2.Left - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Box2.Top - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Overlap = True 'circle2 hit the top left of the box
    End If
    If Abs(Circle2.Left + (Circle2.Width / 2) - Box2.Left - (Box2.Width / 2)) <= (Circle2.Width + Box2.Width) / 2 Then
        If Abs(Circle2.Top + (Circle2.Height / 2) - Box2.Top - (Box2.Height / 2)) <= Box2.Height / 2 Then
            Overlap = True
        End If
    End If
    If Abs(Circle2.Top + (Circle2.Height / 2) - Box2.Top - (Box2.Height / 2)) <= (Circle2.Height + Box2.Height) / 2 Then
        If Abs(Circle2.Left + (Circle2.Width / 2) - Box2.Left - (Box2.Width / 2)) <= Box2.Width / 2 Then
            Overlap = True
        End If
    End If
    If Overlap = True Then
        Circle2Box2.Caption = "Circle2 and Box2 are overlapping"
    Else
        Circle2Box2.Caption = "Circle2 and Box2 are NOT overlapping"
    End If
    
    On Error Resume Next 'If the user is moving no object
    MoveThis.Left = X - (MoveThis.Width / 2)
    MoveThis.Top = Y - (MoveThis.Height / 2)
End Sub
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then
        Set MoveThis = Nothing
        Exit Sub
    End If
    'Collision detection with point & Box1
    If X >= Box1.Left Then
        If X <= Box1.Left + Box1.Width Then
            If Y >= Box1.Top Then
                If Y <= Box1.Top + Box1.Height Then
                    'Within the box boundry
                    Box1.ZOrder (0)
                    Set MoveThis = Box1
                    Exit Sub
                End If
            End If
        End If
    End If
    
    'Collision detection with point & Box2
    If X >= Box2.Left Then
        If X <= Box2.Left + Box2.Width Then
            If Y >= Box2.Top Then
                If Y <= Box2.Top + Box2.Height Then
                    'Within the box boundry
                    Box2.ZOrder (0)
                    Set MoveThis = Box2
                    Exit Sub
                End If
            End If
        End If
    End If
    
    'Collision detection with point & circle1
    If Sqr(CDbl((X - Circle1.Left - (Circle1.Width / 2)) ^ 2) + CDbl((Y - Circle1.Top - (Circle1.Height / 2)) ^ 2)) <= Circle1.Width / 2 Then
        Circle1.ZOrder (0)
        Set MoveThis = Circle1
        Exit Sub
    End If
    
    'Collision detection with point & circle2
    If Sqr(CDbl((X - Circle2.Left - (Circle2.Width / 2)) ^ 2) + CDbl((Y - Circle2.Top - (Circle2.Height / 2)) ^ 2)) <= Circle2.Width / 2 Then
        Circle2.ZOrder (0)
        Set MoveThis = Circle2
        Exit Sub
    End If
End Sub
